git-stash.sh 10.3 KB
Newer Older
しらいしななこ's avatar
しらいしななこ committed
1 2 3
#!/bin/sh
# Copyright (c) 2007, Nanako Shiraishi

4 5
dashless=$(basename "$0" | sed -e 's/-/ /')
USAGE="list [<options>]
Stephen Boyd's avatar
Stephen Boyd committed
6 7 8
   or: $dashless show [<stash>]
   or: $dashless drop [-q|--quiet] [<stash>]
   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9
   or: $dashless branch <branchname> [<stash>]
10
   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
11
   or: $dashless clear"
しらいしななこ's avatar
しらいしななこ committed
12

13
SUBDIRECTORY_OK=Yes
14
OPTIONS_SPEC=
15
START_DIR=`pwd`
しらいしななこ's avatar
しらいしななこ committed
16 17
. git-sh-setup
require_work_tree
18
cd_to_toplevel
しらいしななこ's avatar
しらいしななこ committed
19 20 21 22 23 24

TMP="$GIT_DIR/.git-stash.$$"
trap 'rm -f "$TMP-*"' 0

ref_stash=refs/stash

25 26 27 28 29 30 31 32
if git config --get-colorbool color.interactive; then
       help_color="$(git config --get-color color.interactive.help 'red bold')"
       reset_color="$(git config --get-color '' reset)"
else
       help_color=
       reset_color=
fi

しらいしななこ's avatar
しらいしななこ committed
33
no_changes () {
34 35
	git diff-index --quiet --cached HEAD --ignore-submodules -- &&
	git diff-files --quiet --ignore-submodules
しらいしななこ's avatar
しらいしななこ committed
36 37 38
}

clear_stash () {
39 40 41 42
	if test $# != 0
	then
		die "git stash clear with parameters is unimplemented"
	fi
43
	if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
44
	then
Emil Medve's avatar
Emil Medve committed
45
		git update-ref -d $ref_stash $current
46
	fi
しらいしななこ's avatar
しらいしななこ committed
47 48
}

49
create_stash () {
50 51
	stash_msg="$1"

52
	git update-index -q --refresh
しらいしななこ's avatar
しらいしななこ committed
53 54 55 56
	if no_changes
	then
		exit 0
	fi
57

しらいしななこ's avatar
しらいしななこ committed
58
	# state of the base commit
59
	if b_commit=$(git rev-parse --verify HEAD)
しらいしななこ's avatar
しらいしななこ committed
60
	then
61
		head=$(git rev-list --oneline -n 1 HEAD --)
しらいしななこ's avatar
しらいしななこ committed
62 63 64 65
	else
		die "You do not have the initial commit yet"
	fi

66
	if branch=$(git symbolic-ref -q HEAD)
しらいしななこ's avatar
しらいしななこ committed
67 68 69 70 71 72 73 74
	then
		branch=${branch#refs/heads/}
	else
		branch='(no branch)'
	fi
	msg=$(printf '%s: %s' "$branch" "$head")

	# state of the index
75
	i_tree=$(git write-tree) &&
76
	i_commit=$(printf 'index on %s\n' "$msg" |
77
		git commit-tree $i_tree -p $b_commit) ||
しらいしななこ's avatar
しらいしななこ committed
78 79
		die "Cannot save the current index state"

80 81 82 83 84 85 86 87 88 89
	if test -z "$patch_mode"
	then

		# state of the working tree
		w_tree=$( (
			rm -f "$TMP-index" &&
			cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
			GIT_INDEX_FILE="$TMP-index" &&
			export GIT_INDEX_FILE &&
			git read-tree -m $i_tree &&
90
			git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
91 92 93 94 95 96 97
			git write-tree &&
			rm -f "$TMP-index"
		) ) ||
			die "Cannot save the current worktree state"

	else

98
		rm -f "$TMP-index" &&
99 100 101 102 103 104 105 106
		GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&

		# find out what the user wants
		GIT_INDEX_FILE="$TMP-index" \
			git add--interactive --patch=stash -- &&

		# state of the working tree
		w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
しらいしななこ's avatar
しらいしななこ committed
107 108
		die "Cannot save the current worktree state"

109 110 111 112 113 114 115 116 117
		git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
		test -s "$TMP-patch" ||
		die "No changes selected"

		rm -f "$TMP-index" ||
		die "Cannot remove temporary index (can't happen)"

	fi

しらいしななこ's avatar
しらいしななこ committed
118
	# create the stash
119 120 121 122 123 124 125
	if test -z "$stash_msg"
	then
		stash_msg=$(printf 'WIP on %s' "$msg")
	else
		stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
	fi
	w_commit=$(printf '%s\n' "$stash_msg" |
126
		git commit-tree $w_tree -p $b_commit -p $i_commit) ||
しらいしななこ's avatar
しらいしななこ committed
127
		die "Cannot record working tree state"
128
}
しらいしななこ's avatar
しらいしななこ committed
129

130
save_stash () {
131
	keep_index=
132
	patch_mode=
Stephen Boyd's avatar
Stephen Boyd committed
133 134 135
	while test $# != 0
	do
		case "$1" in
136
		-k|--keep-index)
Stephen Boyd's avatar
Stephen Boyd committed
137 138
			keep_index=t
			;;
139 140 141 142 143
		--no-keep-index)
			keep_index=
			;;
		-p|--patch)
			patch_mode=t
Stephen Boyd's avatar
Stephen Boyd committed
144 145 146 147 148
			keep_index=t
			;;
		-q|--quiet)
			GIT_QUIET=t
			;;
149 150 151 152 153 154
		--)
			shift
			break
			;;
		-*)
			echo "error: unknown option for 'stash save': $1"
155
			echo "       To provide a message, use git stash save -- '$1'"
156 157
			usage
			;;
Stephen Boyd's avatar
Stephen Boyd committed
158 159 160 161
		*)
			break
			;;
		esac
162
		shift
Stephen Boyd's avatar
Stephen Boyd committed
163
	done
164

165
	stash_msg="$*"
166

167
	git update-index -q --refresh
168 169
	if no_changes
	then
Stephen Boyd's avatar
Stephen Boyd committed
170
		say 'No local changes to save'
171 172 173 174 175 176
		exit 0
	fi
	test -f "$GIT_DIR/logs/$ref_stash" ||
		clear_stash || die "Cannot initialize stash"

	create_stash "$stash_msg"
Emil Medve's avatar
Emil Medve committed
177 178 179

	# Make sure the reflog for stash is kept.
	: >>"$GIT_DIR/logs/$ref_stash"
しらいしななこ's avatar
しらいしななこ committed
180

181
	git update-ref -m "$stash_msg" $ref_stash $w_commit ||
しらいしななこ's avatar
しらいしななこ committed
182
		die "Cannot save the current status"
Stephen Boyd's avatar
Stephen Boyd committed
183
	say Saved working directory and index state "$stash_msg"
184

185
	if test -z "$patch_mode"
186
	then
187 188 189 190 191 192 193 194 195 196 197 198 199 200
		git reset --hard ${GIT_QUIET:+-q}

		if test -n "$keep_index" && test -n $i_tree
		then
			git read-tree --reset -u $i_tree
		fi
	else
		git apply -R < "$TMP-patch" ||
		die "Cannot remove worktree changes"

		if test -z "$keep_index"
		then
			git reset
		fi
201
	fi
しらいしななこ's avatar
しらいしななこ committed
202 203
}

204
have_stash () {
205
	git rev-parse --verify $ref_stash >/dev/null 2>&1
206 207
}

しらいしななこ's avatar
しらいしななこ committed
208
list_stash () {
209
	have_stash || return 0
210
	git log --format="%gd: %gs" -g "$@" $ref_stash --
しらいしななこ's avatar
しらいしななこ committed
211 212 213
}

show_stash () {
214
	assert_stash_like "$@"
215

216
	git diff ${FLAGS:---stat} $b_commit $w_commit
しらいしななこ's avatar
しらいしななこ committed
217 218
}

219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270
#
# Parses the remaining options looking for flags and
# at most one revision defaulting to ${ref_stash}@{0}
# if none found.
#
# Derives related tree and commit objects from the
# revision, if one is found.
#
# stash records the work tree, and is a merge between the
# base commit (first parent) and the index tree (second parent).
#
#   REV is set to the symbolic version of the specified stash-like commit
#   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
#   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
#   s is set to the SHA1 of the stash commit
#   w_commit is set to the commit containing the working tree
#   b_commit is set to the base commit
#   i_commit is set to the commit containing the index tree
#   w_tree is set to the working tree
#   b_tree is set to the base tree
#   i_tree is set to the index tree
#
#   GIT_QUIET is set to t if -q is specified
#   INDEX_OPTION is set to --index if --index is specified.
#   FLAGS is set to the remaining flags
#
# dies if:
#   * too many revisions specified
#   * no revision is specified and there is no stash stack
#   * a revision is specified which cannot be resolve to a SHA1
#   * a non-existent stash reference is specified
#

parse_flags_and_rev()
{
	test "$PARSE_CACHE" = "$*" && return 0 # optimisation
	PARSE_CACHE="$*"

	IS_STASH_LIKE=
	IS_STASH_REF=
	INDEX_OPTION=
	s=
	w_commit=
	b_commit=
	i_commit=
	w_tree=
	b_tree=
	i_tree=

	REV=$(git rev-parse --no-flags --symbolic "$@" 2>/dev/null)

	FLAGS=
Jon Seymour's avatar
Jon Seymour committed
271
	for opt
272
	do
Jon Seymour's avatar
Jon Seymour committed
273 274 275 276
		case "$opt" in
			-q|--quiet)
				GIT_QUIET=-t
			;;
277 278 279
			--index)
				INDEX_OPTION=--index
			;;
Jon Seymour's avatar
Jon Seymour committed
280 281
			-*)
				FLAGS="${FLAGS}${FLAGS:+ }$opt"
282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314
			;;
		esac
	done

	set -- $REV

	case $# in
		0)
			have_stash || die "No stash found."
			set -- ${ref_stash}@{0}
		;;
		1)
			:
		;;
		*)
			die "Too many revisions specified: $REV"
		;;
	esac

	REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"

	i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
	set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
	s=$1 &&
	w_commit=$1 &&
	b_commit=$2 &&
	w_tree=$3 &&
	b_tree=$4 &&
	i_tree=$5 &&
	IS_STASH_LIKE=t &&
	test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
	IS_STASH_REF=t

315 316 317 318 319 320 321 322 323
	if test "${REV}" != "${REV%{*\}}"
	then
		# maintainers: it would be better if git rev-parse indicated
		# this condition with a non-zero status code but as of 1.7.2.1 it
		# it did not. So, we use non-empty stderr output as a proxy for the
		# condition of interest.
		test -z "$(git rev-parse "$REV" 2>&1 >/dev/null)" || die "$REV does not exist in the stash log"
	fi

324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343
}

is_stash_like()
{
	parse_flags_and_rev "$@"
	test -n "$IS_STASH_LIKE"
}

assert_stash_like() {
	is_stash_like "$@" || die "'$*' is not a stash-like commit"
}

is_stash_ref() {
	is_stash_like "$@" && test -n "$IS_STASH_REF"
}

assert_stash_ref() {
	is_stash_ref "$@" || die "'$*' is not a stash reference"
}

しらいしななこ's avatar
しらいしななこ committed
344
apply_stash () {
Stephen Boyd's avatar
Stephen Boyd committed
345

346
	assert_stash_like "$@"
しらいしななこ's avatar
しらいしななこ committed
347

348 349 350 351 352 353 354 355
	git update-index -q --refresh &&
	git diff-files --quiet --ignore-submodules ||
		die 'Cannot apply to a dirty working tree, please stage your changes'

	# current index state
	c_tree=$(git write-tree) ||
		die 'Cannot apply a stash in the middle of a merge'

Junio C Hamano's avatar
Junio C Hamano committed
356
	unstashed_index_tree=
357
	if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
358
			test "$c_tree" != "$i_tree"
Junio C Hamano's avatar
Junio C Hamano committed
359
	then
360
		git diff-tree --binary $s^2^..$s^2 | git apply --cached
361 362
		test $? -ne 0 &&
			die 'Conflicts in index. Try without --index.'
363
		unstashed_index_tree=$(git write-tree) ||
364 365
			die 'Could not save index tree'
		git reset
Junio C Hamano's avatar
Junio C Hamano committed
366
	fi
367

しらいしななこ's avatar
しらいしななこ committed
368 369 370 371 372 373 374
	eval "
		GITHEAD_$w_tree='Stashed changes' &&
		GITHEAD_$c_tree='Updated upstream' &&
		GITHEAD_$b_tree='Version stash was based on' &&
		export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
	"

Stephen Boyd's avatar
Stephen Boyd committed
375 376
	if test -n "$GIT_QUIET"
	then
377
		GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
Stephen Boyd's avatar
Stephen Boyd committed
378
	fi
379
	if git merge-recursive $b_tree -- $c_tree $w_tree
しらいしななこ's avatar
しらいしななこ committed
380 381
	then
		# No conflict
Junio C Hamano's avatar
Junio C Hamano committed
382 383 384
		if test -n "$unstashed_index_tree"
		then
			git read-tree "$unstashed_index_tree"
385 386
		else
			a="$TMP-added" &&
387
			git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
388 389 390 391
			git read-tree --reset $c_tree &&
			git update-index --add --stdin <"$a" ||
				die "Cannot unstage modified files"
			rm -f "$a"
Junio C Hamano's avatar
Junio C Hamano committed
392
		fi
Stephen Boyd's avatar
Stephen Boyd committed
393 394 395 396 397
		squelch=
		if test -n "$GIT_QUIET"
		then
			squelch='>/dev/null 2>&1'
		fi
398
		(cd "$START_DIR" && eval "git status $squelch") || :
しらいしななこ's avatar
しらいしななこ committed
399 400
	else
		# Merge conflict; keep the exit status from merge-recursive
401
		status=$?
402
		if test -n "$INDEX_OPTION"
Junio C Hamano's avatar
Junio C Hamano committed
403 404 405
		then
			echo >&2 'Index was not unstashed.'
		fi
406
		exit $status
しらいしななこ's avatar
しらいしななこ committed
407 408 409
	fi
}

410 411 412 413 414 415 416
pop_stash() {
	assert_stash_ref "$@"

	apply_stash "$@" &&
	drop_stash "$@"
}

417
drop_stash () {
418
	assert_stash_ref "$@"
419

420 421
	git reflog delete --updateref --rewrite "${REV}" &&
		say "Dropped ${REV} ($s)" || die "${REV}: Could not drop stash entry"
422 423

	# clear_stash if we just dropped the last stash entry
424
	git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
425 426
}

427 428 429
apply_to_branch () {
	test -n "$1" || die 'No branch name specified'
	branch=$1
430
	shift 1
431

432 433 434 435
	set -- --index "$@"
	assert_stash_like "$@"

	git checkout -b $branch $REV^ &&
436 437 438
	apply_stash "$@" && {
		test -z "$IS_STASH_REF" || drop_stash "$@"
	}
439 440
}

441
PARSE_CACHE='--not-parsed'
442 443 444 445 446 447 448 449 450 451 452 453
# The default command is "save" if nothing but options are given
seen_non_option=
for opt
do
	case "$opt" in
	-*) ;;
	*) seen_non_option=t; break ;;
	esac
done

test -n "$seen_non_option" || set "save" "$@"

しらいしななこ's avatar
しらいしななこ committed
454 455
# Main command set
case "$1" in
456 457
list)
	shift
しらいしななこ's avatar
しらいしななこ committed
458 459 460 461 462 463
	list_stash "$@"
	;;
show)
	shift
	show_stash "$@"
	;;
464 465
save)
	shift
466
	save_stash "$@"
467
	;;
しらいしななこ's avatar
しらいしななこ committed
468 469 470 471 472
apply)
	shift
	apply_stash "$@"
	;;
clear)
473 474
	shift
	clear_stash "$@"
しらいしななこ's avatar
しらいしななこ committed
475
	;;
476 477 478 479 480 481 482
create)
	if test $# -gt 0 && test "$1" = create
	then
		shift
	fi
	create_stash "$*" && echo "$w_commit"
	;;
483 484 485 486
drop)
	shift
	drop_stash "$@"
	;;
487 488
pop)
	shift
489
	pop_stash "$@"
490
	;;
491 492 493 494
branch)
	shift
	apply_to_branch "$@"
	;;
しらいしななこ's avatar
しらいしななこ committed
495
*)
496 497
	case $# in
	0)
498
		save_stash &&
Stephen Boyd's avatar
Stephen Boyd committed
499
		say '(To restore them type "git stash apply")'
500 501
		;;
	*)
502
		usage
503
	esac
504
	;;
しらいしななこ's avatar
しらいしななこ committed
505
esac